
Fire = Core.class(Bitmap)

-- create a new projectile
function Fire:init(texture, speedX, speedY, x, y)
	stage:addChild(self)
  
  local w, h = self:getWidth(), self:getHeight()
  self.w, self.h = w, h
  
	self.x = x
	self.y = y
  
  self.speedX = speedX
	self.speedY = speedY
  
  self:setAnchorPoint(0.5, 0.5)
  self:setPosition(self.x, self.y)

--	self:addEventListener(Event.ENTER_FRAME, self.update, self)
end

-- remove event listeners and remove from stage
function Fire:dispose()
		--stage:removeEventListener(Event.ENTER_FRAME, self.update, self)
    self:removeFromParent()
end

-- update every frame
function Fire:update(event)
  local x = self.x + self.speedX -- get new position
  local y = self.y + self.speedY
  
  if y < -32 or y > 480 or x < 0 or x > 320 then
    -- left screen, dispose
    self:dispose()
  else
    -- process
    self.x, self.y = x, y -- set position
    self:setPosition(x, y)
    
    -- check collision versus all gears and dispose both objects if they do collide
    local gears = GAME.gears
    for i = gears:getNumChildren(), 1, -1 do
      local gear = gears:getChildAt(i)
      if self:collidesWith(gear) then
        gear:dispose()
        self:dispose()
      end
    end
  
  end
end

-- returns true of self collides with other
function Fire.collidesWith(self, other)
  local px, py = self.x, self.y
	local x, y, w, h = other.x, other.y, other.w, other.h
  
  local DELTA = 1e-10
  return px - x > DELTA      and py - y > DELTA and
         x + w - px > DELTA  and y + h - py > DELTA
  
  --local x1, y1, w1, h1 = self.x, self.y, self.w, self.h
--	local x2, y2, w2, h2 = other.x, other.y, other.w, other.h
--  return x1 < x2+w2 and x2 < x1+w1 and y1 < y2+h2 and y2 < y1+h1
end
